{ Zerlegen einer Bitmap in einzelne Segmente }
{ Siro 20.09.2017 }
{ es muss sich eine Bilmap namens: "TestBild.bmp" im Verzeichnis befinden, }
{ ansonsten den Code QuellBitmap.LoadFromFile('TestBild.bmp'); ändern }


unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Windows,Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs;

type

  { TForm1 }

  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

var QuellBitmap : TBitmap;

  { Bitmap soll aufgeteilt werden in }
const X_FELDER = 4;
const Y_FELDER = 4;

var ZielBitmap  : Array[0..X_FELDER-1,0..Y_FELDER-1] of TBitmap;

var AutoWidth  : Integer;
var AutoHeight : Integer;

procedure TForm1.FormCreate(Sender: TObject);
var x,y:Integer;
begin
  QuellBitmap:=TBitmap.create;
  QuellBitmap.LoadFromFile('TestBild.bmp');

  {automatische Größe anpassung, Global speichern, wird für Paint benötigt }
  AutoWidth  := QuellBitmap.width  DIV X_FELDER;
  AutoHeight := QuellBitmap.height DIV Y_FELDER;

  { Ziel Bitmap Objekte erzeugen }
  for x:=0 to X_FELDER-1 do for y:=0 to Y_FELDER-1 do begin
    ZielBitmap[x,y]:=TBitmap.create;
    ZielBitmap[x,y].SetSize(AutoWidth,AutoHeight);   { Breite und Höhe der Bitmaps setzen }

    BitBlt(
    ZielBitmap[x,y].canvas.handle, { Handle der Ziel Bitmap }
    0,                             { Ziel Koordinate X = 0 }
    0,                             { Ziel Koordinate Y = 0 }
    AutoWidth,                     { Breite der ZielBitmap }
    AutoHeight,                    { Höhe   der ZielBitmap }
    QuellBitmap.canvas.Handle,     { Handle der Quell Bitmap }
    AutoWidth  * x,                { Quellposition X Position innerhalb der großen Bitmap }
    AutoHeight * y,                { Quellposition Y Position innerhalb der großen Bitmap }
    SRCCOPY);                      { Kopierfunktion }
  end;

end;

procedure TForm1.FormDestroy(Sender: TObject);
var x,y:Integer;
begin
  for x:=0 to X_FELDER-1 do for y:=0 to Y_FELDER-1 do
    ZielBitmap[x,y].free;
end;

procedure TForm1.FormPaint(Sender: TObject);
var x,y:Integer;
begin
  for x:=0 to X_FELDER-1 do for y:=0 to Y_FELDER-1 do begin
    canvas.Draw(x*(AutoWidth+3),y*(AutoHeight+3),ZielBitmap[x,y]);
  end;
end;

end.

